#!/bin/sh

# this is example notify script that can be invoked on a server side
# This script will be called by dibbler-server with a single parameter
# describing operation (add, update, delete, expire)
#
# Many parameters will be passed as environment variables
LOGFILE=/opt/var/log/dibbler/dibbler-server-notify.log

# 2= debug, 1= Log eingeschaltet, 0= Log deaktiviert
LOG="0"

######### no change from here  ###############################################
STATUS=$1
if [ "$LOG" == "2" ] 
then
        # uncomment this to get full list of available variables
        echo "--- $STATUS -------------------------------------------------------" >> $LOGFILE
        date >> $LOGFILE
	set >> $LOGFILE
fi

if [ "$STATUS" == "update" ] 
then
	if [ "$LOG" != "0" ]
	then
    	echo "--- $1 -------------------------------------------------------" >> $LOGFILE                                                                                           
        date >> $LOGFILE                                                                                                   
		echo "UPDATE: Prefix $PREFIX1 to client $REMOTE_ADDR on inteface $IFACE/$IFINDEX - nothing to do..." >> $LOGFILE
	fi
fi

if [ "$STATUS" == "expire" ]
then 
    	echo "--- $1 -------------------------------------------------------" >> $LOGFILE                                                                                           
        date >> $LOGFILE                                                                                                   
		echo "EXPIRE: Prefix $PREFIX1 to client $REMOTE_ADDR on inteface $IFACE/$IFINDEX - nothing to do..." >> $LOGFILE
fi

if [ "$STATUS" == "delete" ]
then
	/bin/ip -6 route del $PREFIX1/$PREFIX1LEN
	/bin/ip -6 route del $PREFIX1/$PREFIX1LEN table 200
	/bin/ip -6 route del $PREFIX1/$PREFIX1LEN table 201
	if [ "$LOG" != "0" ]
	then
		echo "--- $1 -------------------------------------------------------" >> $LOGFILE
		date >> $LOGFILE
   		echo "DELETE: Old ${PREFIX1} routing entry deleted ..." >> $LOGFILE
	fi
fi

if [ "$STATUS" == "add" ]
then 
	ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256
	ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 1024 table 200
	ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 1024 table 201
	echo "/bin/ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256" >> /opt/var/lib/dibbler/undo_ipv6_route.sh
	echo "/bin/ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256 table 200" >> /opt/var/lib/dibbler/undo_ipv6_route.sh
 	echo "/bin/ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256 table 201" >> /opt/var/lib/dibbler/undo_ipv6_route.sh
  	if [ "$LOG" != "0" ]
  	then
		echo "--- $1 -------------------------------------------------------" >> $LOGFILE
		date >> $LOGFILE
    	echo "ADD: Routing $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256 enabled ..." >> $LOGFILE   
  	fi
fi

# sample return code. Dibbler will just print it out.
exit 3